%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% if distance exists find d & l
%      
%          l
%       +____|   + = can
%        \   |   theta=tan^-1(l/d)
%       d \  |
%          \ |
%           \|
%            0   0=camera



function [can_positive,dist,angle, direction]=cansearch%(A)
%direction:
%       1=left half
%       2=center
%       3=right half
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%creates test rec with blured edger
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

A=IMREAD ('http://localhost:8080/');%   '25cm.jpg'); %('http://localhost:8080/');
A=A(:,:,2);             %only green pixels
A=mat2gray(A);          %take down from 3D matrix to 1D
%figure(1), imshow(A,[])

b=im2bw(A, .5);         %set the can values to either 1(white)
b=~b;                   %or 2(black)
b=double(b);
%figure, imshow (b)

se=strel('square',8);  %gets rid of noise
fe2 = imerode(b,se);      
%figure, imshow(fe2)

f=edge(fe2, 'sobel');  %edge detector
%figure, imshow(f)

B=[0,1,0;1,1,1;0,1,0];  %diolating for more complete borders
fd=imdilate(f,B);
%figure, imshow(fd)

fd=~fd;
se=strel('square',10);   %little extra diolating
fs=imerode(fd,se);
fs=~fs;
%figure, imshow(fs)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%creates fitting and not fitting templates
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
can_positive=0;            %resets flag that says no can is found yet

for i=0:22          %goes thorugh the loop 23 times (0 counts)  
                    %start a largest template and move to smallest
                    %all templates have same 13x7 ratio
    r=82-i*2;       % 243 r=rows c=col i want them to keep the 13*7  ratio
    c=(r*7)/13;     %r/c=13/7 (want 13*7 ratio)
    c=round(c);
    
    clear t;        %t is current test template that will run through the
    t=zeros(r,c);   %pic to see if there is a match
    t=double(t);
    t(1,1:c)=1;
    t(r,1:c)=1;
    t(1:r,1)=1;
    t(1:r,c)=1;
    
    g=filter2(t,fs);    
    [m,y]=max(g(:));
    %i               %this is for trouble shooting, it will display what 
                     %loop i am on in real time
                     
    if m==sum(sum(t));           %we have a positive match
      can_positive=1;                  %sets flag that there is a can (output)
      %figure, imshow(fs)
      %figure, imshow(t)
      %figure, imshow(g>(m-1))   %show's "dot" of center of mass if can 
                                 %found
      fs(1:2,1:c)=1;
    fs(r-1:r,1:c)=1;
    fs(1:r,1:2)=1;
    fs(1:r,c-1:c)=1;
    %figure(2), imshow(A,[])
    %figure(2), imshow(fs)
                                 
      break 
    
    
    end
end
    fs(1:2,1:c)=1;
    fs(r-1:r,1:c)=1;
    fs(1:r,1:2)=1;
    fs(1:r,c-1:c)=1;
figure(2), imshow(A,[])
figure(2), imshow(fs)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%template distance, finding d (see top of code)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if can_positive==1         %if it exists give distance
    if i==0
        dist=052;
    elseif i==1
        dist=053;
    elseif i==2
        dist=057;     
    elseif i==3
        dist=060;     
    elseif i==4
        dist=064;     
    elseif i==5
        dist=067;
    elseif i==6
        dist=070;     
    elseif i==7
        dist=073;     
    elseif i==8
        dist=077;
    elseif i==9
        dist=080;     
    elseif i==10
        dist=083;     
    elseif i==11
        dist=087;
    elseif i==12
        dist=091;    
    elseif i==13
        dist=095;
    elseif i==14
        dist=099;     
    elseif i==15
        dist=104;
    elseif i==16
        dist=109;     
    elseif i==17
        dist=114;
    elseif i==18
        dist=120;     
    elseif i==19
        dist=126;
    elseif i==20
        dist=133;
    elseif i==21
        dist=141;
    elseif i==22
        dist=149;
   
    end
else
    dist=0;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%finding distance from x=0 (or l, see top of code)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
angle_zero=0;                   %reset angle var
angle=0;
direction=0;
if can_positive==1              %if there is a can...
    gm=g>(m-1);
    [a,col]=max(max(g));       %gives the row and col's of the max point, or dot
    [a,row]=max(g(:,col));
    
    if col>160                  %deturmines if the can is on the right/left/or center of pic
        direction=3;            %3=right
        ncol=col-160;           %distance from x=0 (middle)
        l=.2255*(ncol)-1.528; %l is distance in cm calc from the pixels
    elseif col==160
        direction=2;            %2=CENTER
        ncol=0;
        angle_zero=1;
    elseif col<160
        direction=1;            %1=left
        ncol=160-col;
        l=.2255*(ncol)-1.528; 
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%find angle
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if can_positive==1
    if angle_zero==1        %a flag is set if angle=0
        angle_zero=0;
        angle=0;
        return %break;
    else
        angle_rad=asin(l/dist);   %matlab gives rad...good to know
        angle=angle_rad*(180/pi);
        %dist
    end
end
        
    
     